require 'nokogiri'
require 'open-uri'
require 'json' 

class Book < Struct.new(:title, :cover_img, :url); end  
class Struct
  def to_map
    map = Hash.new
    self.members.each { |m| map[m] = self[m] }
    map 
  end 

  def to_json(*a)
    to_map.to_json(*a)
  end 
end

class Pragmatic
  def self.media
    uri = URI 'http://pragprog.com/categories/all'
    doc = Nokogiri::HTML(open uri) 

    works = doc.css('.thumbnail')
    titles =  works.collect{|w| w.css('img').first.attributes['alt'].text.gsub('Cover Image For ','').gsub('...','') } 
    covers = works.collect{|w| w.css("img").first.attributes['src'].text}
    urls = works.collect{|w| w.css("a").first.attributes['href'].text}
    books = titles.zip(covers,urls).inject([]) do |books, book| 
      books << Book.new(*book) 
    end 

    JSON.parse(books.to_json) 
  end 
end 




